program CAOClient;
{$APPTYPE CONSOLE}

(*
 * To compile, make sure you have the BorCon2003.dll in this same directory, 
 * generated from the BorCon2003.cs (which is located in the ..\c#\assemblies
 * directory).
 *
 * dccil -luBorCon2003 CAOClient.dpr 
 *
 * Use this client application with CAOServer
 *
 *)


uses
  RickRoss.BorCon2003, // imported from BorCon2003
  System.Collections,
  System.Runtime.Remoting,
  System.Runtime.Remoting.Channels.Http,
  System.Runtime.Remoting.Channels;

const
  SERVER_URI = 'http://localhost:2003/BorCon2003RemoteObjectFactory.soap';
  VALUE_TO_SET = 2003;

var
  aChannel : HttpChannel;
  iexf1    : IExample1Factory;
  iex1     : IExample1;
  iex2     : IExample1;

begin
  writeln('Remote client is creating HTTP channel...');
  aChannel := HttpChannel.Create;
  writeln('registering client channel');
  ChannelServices.RegisterChannel( aChannel );
  writeln('obtaining reference to server factory object...');
  iexf1 := Activator.GetObject( 
             typeof(IExample1Factory), SERVER_URI ) as 
             IExample1Factory;
  writeln('creating a new instance from the factory...');
  iex1  := iexf1.GetNewInstance();
  writeln('object reference has been acquired...');
  writeln('Getting a value ', iex1.GetValue() );
  writeln('Setting a value');
  iex1.SetValue(77);
  writeln('Getting value again...', iex1.GetValue() );
  writeln('creating a new instance from the factory...');  
  iex2 := iexf1.GetNewInstance( 55 );
  writeln('object reference has been acquired...');
  writeln('Getting a value ', iex2.GetValue() );
  writeln('Setting a value');
  iex2.SetValue(33);
  writeln('Getting value again...', iex2.GetValue() );
end.

