program ExampleClient1;
{$APPTYPE CONSOLE}

(*
 * To compile, make sure you have the BorCon2003.dll in this same directory, 
 * generated from the BorCon2003.cs (which is located in the ..\c#\assemblies
 * directory).
 *
 * dccil -luBorCon2003 ExampleClient1.dpr 
 *
 * Use this client for connecting to the following server applications:
 *
 *   SingleCallServer
 *   SingletonServer
 *   PublishedServer
 *   SingletonLiveForeverServer
 *
 *)

uses
  RickRoss.BorCon2003, // imported from BorCon2003.dll
  System.Collections,
  System.Runtime.Remoting,
  System.Runtime.Remoting.Channels.Http,
  System.Runtime.Remoting.Channels;

const
  SERVER_URI = 'http://localhost:2003/BorCon2003RemoteObject.soap';
  VALUE_TO_SET = 2003;

var
  aChannel : HttpChannel;
  iex1     : IExample1;

begin
  writeln('Remote client is creating HTTP channel...');
  aChannel := HttpChannel.Create;
  writeln('registering client channel');
  ChannelServices.RegisterChannel( aChannel );
  writeln('obtaining reference to server...');
  iex1 := Activator.GetObject( 
             typeof(IExample1), SERVER_URI ) as 
             IExample1;
  writeln('object reference has been acquired...');
  writeln('Getting a value ', iex1.GetValue() );
  writeln('Setting a value');
  iex1.SetValue(77);
  writeln('Getting value again...', iex1.GetValue() );
end.

