program SingletonServer;
{$APPTYPE CONSOLE}

(*
 * To compile, make sure you have the BorCon2003.dll in this same directory, 
 * generated from the BorCon2003.cs (which is located in the ..\c#\assemblies
 * directory).
 *
 * dccil -luBorCon2003 SingletonServer.dpr 
 *
 * Use this server application with either the Delphi or C# ExampleClient1 client
 *
 *)

uses
  RickRoss.BorCon2003, // imported from BorCon2003.dll
  System.Runtime.Remoting,
  System.Runtime.Remoting.Channels.Http,
  System.Runtime.Remoting.Channels;  

type
  TMyRemoteObject = class( MarshalByRefObject, IExample1 )
  private
    FValue : integer;
  public
    procedure SetValue( value : integer );
    function  GetValue : integer;
  end;

procedure TMyRemoteObject.SetValue( value : integer );
begin
  writeln('Server: Setting value to ', value);
  FValue := value;
end;

function  TMyRemoteObject.GetValue : integer;
begin
  writeln('Server: getting value ', FValue );
  Result := FValue;
end;

var
  aChannel : HttpChannel;

begin
  writeln('RemoteServer (Singleton) starting...');
  aChannel := HttpChannel.Create( 2003 ); // port number
  writeln('Server: Registering channel...');
  ChannelServices.RegisterChannel( aChannel );
  writeln('Server: Registering type...');
  RemotingConfiguration.RegisterWellKnownServiceType( typeof(TMyRemoteObject), 
         'BorCon2003RemoteObject.soap',
         WellKnownObjectMode.Singleton );
  writeln('Press return to shut down the server...');
  readln;  
end.
